//********************************************************************************************************************************
//*                                                                                                                              *
//*     TRegistration 2.1.24.299  3delite 2006-2024                                                                             *
//*     See TRegistration ReadMe.txt for details                                                                                 *
//*                                                                                                                              *
//* Two licenses are available if you like this component:                                                                       *
//* Shareware license: 125                                                                                                      *
//*     http://www.shareit.com/product.html?productid=300091298                                                                  *
//* Commercial license: 250                                                                                                     *
//*     http://www.shareit.com/product.html?productid=300091297                                                                  *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object Pascal Developer Resources/tregistration.html                                              *
//*                                                                                                                              *
//* If you have any of the aforementioned please email: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit Main;

interface

uses
    Windows, 
    Messages, 
    SysUtils, 
    Variants,
    Classes, 
    Graphics, 
    Controls,
    UITypes,
    Forms, 
    Dialogs, 
    StdCtrls, 
    ComCtrls, 
    Inifiles, 
    ShellApi, 
    CalcReg,
    Clipbrd,
    Menus,
    RegistrationDefs, 
    //Helper3delite,
    ImgList,
    DB,
    ADODB, 
    ExtCtrls, 
    //VersionUpdateDefs,
    TrayIcon, System.ImageList;

Const
    //STR_PROJECTS_FILE = 'ProjectNames.txt';
    //STR_SETTINGS_FILE = 'Settings.ini';
    //STR_SUBVERSION_FILE = 'SubversionData.txt';
    STR_SEARCH_STRINGS = 'Search strings.txt';
    WWW_TREGISTRATION = 'http://www.3delite.hu/Object%20Pascal%20Developer%20Resources/tregistration.html';

Const
    //* Messages
    MSG_TRAY_ICON    = WM_USER + 111;

    NIN_BALLOONSHOW = WM_USER + 2;
    NIN_BALLOONHIDE = WM_USER + 3;
    NIN_BALLOONTIMEOUT = WM_USER + 4;
    NIN_BALLOONUSERCLICK = WM_USER + 5;
    NIN_SELECT = WM_USER + 0;
    NINF_KEY = $1;
    NIN_KEYSELECT = NIN_SELECT or NINF_KEY;

Const
    TN_SETTINGS = 'Settings';
    CN_SETTINGS_ID = 'SettingsID';
    CN_SETTINGS_VERSION = 'Version';
    //* V3
    CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_REGISTRATION = 'DefaultEMailTemplateRegistration';
    CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE = 'DefaultEMailTemplateVersionCode';
    //* v6
    CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE_ERROR = 'DefaultEMailTemplateVersionCodeError';
    //* V5
    CN_SETTINGS_EMAIL_CHECK_INTERVAL = 'EmailCheckInterval';
    //* Incoming
    CN_SETTINGS_EMAIL_INCOMING_GUID = 'EmailIncomingGUID';
    CN_SETTINGS_EMAIL_INCOMING_ItemName = 'EmailIncomingItemName';
    CN_SETTINGS_EMAIL_INCOMING_Active = 'EmailIncomingActive';
    CN_SETTINGS_EMAIL_INCOMING_HostName = 'EmailIncomingHostName';
    CN_SETTINGS_EMAIL_INCOMING_Port = 'EmailIncomingPort';
    CN_SETTINGS_EMAIL_INCOMING_LoginName = 'EmailIncomingLoginName';
    CN_SETTINGS_EMAIL_INCOMING_Password = 'EmailIncomingPassword';
    CN_SETTINGS_EMAIL_INCOMING_Security = 'EmailIncomingSecurity';
    CN_SETTINGS_EMAIL_INCOMING_SSLMethod = 'EmailIncomingSSLMethod';
    CN_SETTINGS_EMAIL_INCOMING_ServerType = 'EmailIncomingServerType';
    //* Incoming version code requests
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID = 'EmailIncomingVerCodeGUID';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName = 'EmailIncomingVerCodeItemName';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active = 'EmailIncomingVerCodeActive';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName = 'EmailIncomingVerCodeHostName';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port = 'EmailIncomingVerCodePort';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName = 'EmailIncomingVerCodeLoginName';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password = 'EmailIncomingVerCodePassword';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security = 'EmailIncomingVerCodeSecurity';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod = 'EmailIncomingVerCodeSSLMethod';
    CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType = 'EmailIncomingVerCodeServerType';
    //* OUTGOING
    CN_SETTINGS_EMAIL_OUTGOING_GUID = 'EmailOutgoingGUID';
    CN_SETTINGS_EMAIL_OUTGOING_ItemName = 'EmailOutgoingItemName';
    CN_SETTINGS_EMAIL_OUTGOING_Active = 'EmailOutgoingActive';
    CN_SETTINGS_EMAIL_OUTGOING_HostName = 'EmailOutgoingHostName';
    CN_SETTINGS_EMAIL_OUTGOING_Port = 'EmailOutgoingPort';
    CN_SETTINGS_EMAIL_OUTGOING_LoginName = 'EmailOutgoingLoginName';
    CN_SETTINGS_EMAIL_OUTGOING_Password = 'EmailOutgoingPassword';
    CN_SETTINGS_EMAIL_OUTGOING_Security = 'EmailOutgoingSecurity';
    CN_SETTINGS_EMAIL_OUTGOING_SSLMethod = 'EmailOutgoingSSLMethod';
    CN_SETTINGS_EMAIL_OUTGOING_ServerType = 'EmailOutgoingServerType';
    //* E-mail address
    CN_EMAIL_SENDER_ADDRESS = 'EmailSenderAddress';
    CN_EMAIL_FORWARD_ADDRESS = 'EmailForwardAddress';
    CN_EMAIL_SUPPORT_ADDRESS = 'EmailSupportAddress';

    CN_AllBundleProductName = 'AllBundleProductName';


    CURRENT_SETTINGS_VERSION = 5;

    TN_PROJECTS = 'Projects';
    CN_PROJECTNAME = 'ProjectName';
    CN_PROJECT_TABLENAME = 'TableName';
    CN_PROJECT_REG_SEED = 'RegistrationNumberSeed';
    CN_PROJECT_ICON = 'Icon';
    //* V5
    CN_PROJECT_DOWNLOAD_URL = 'DownloadURL';
    //* V3
    CN_PROJECT_EMAIL_TEMPLATE_REGISTRATION = 'EMailTemplateRegistration';
    CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE = 'EMailTemplateVersionCode';
    //* v6
    CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE_ERROR = 'EMailTemplateVersionCodeError';

    TN_PROJECTS_SUBVERSION = 'SubVersions';
    CN_PROJECT_ID = 'ProjectID';
    CN_SUBVERSION_NAME = 'SubVerisonName';
    CN_SUBVERSION_VERCODE_SEED = 'VersionCodeSeed';

    CN_USER_ID = 'ID';
    CN_USER_REGISTRATIONNAME = 'Name';
    CN_USER_EMAIL = 'Email';
    CN_USER_REG_TIME = 'RegistrationTime';
    CN_USER_COMMENTS = 'Comment';
    //* V4
    CN_USER_SALUTATION = 'Salutation';
    CN_USER_TITLE = 'Title';
    CN_USER_LASTNAME = 'LastName';
    CN_USER_FIRSTNAME = 'FirstName';
    CN_USER_COMPANY = 'Company';
    CN_USER_CONTACTNAME = 'ContactName';
    CN_USER_ADDRESS = 'Address';
    CN_USER_CITY = 'City';
    CN_USER_FULLCITY = 'FullCity';
    CN_USER_COUNTRY = 'Country';
    CN_USER_POSTALCODE = 'PostalCode';
    CN_USER_STATEPROVINCE = 'StateProvince';
    CN_USER_TELEPHONE = 'Telephone';
    CN_USER_MOBILEPHONE = 'MobilePhone';
    CN_USER_FAX = 'Fax';
    CN_USER_HOMEPAGE = 'HomePage';
    CN_USER_NEWSLETTER = 'AcceptsNewsLetters';
    CN_USER_VATID = 'VATID';
    CN_USER_NOOFLICENSES = 'NoOfLicenses';
    CN_USER_LANGUAGE = 'Language';
    CN_USER_SHAREITREFNO = 'ShareItRefNo';
    CN_USER_RESELLER = 'Reseller';
    CN_USER_PROMOTIONNAME = 'PromotionName';
    CN_USER_NETSALESCURRENCY = 'NetSalesCurrency';
    CN_USER_NETSALES = 'NetSales';
    CN_USER_NETDISCOUNTCURRENCY = 'NetDiscountCurrency';
    CN_USER_NETDISCOUNT = 'NetDiscount';
    CN_USER_COLLECTEDVATCURRENCY = 'CollectedVATCurrency';
    CN_USER_COLLECTEDVAT = 'CollectedVAT';
    CN_USER_SHIPPINGCURRENCY = 'ShippingCurrency';
    CN_USER_SHIPPING = 'Shipping';
    CN_USER_VATSHIPPINGCURRENCY = 'VATShippingCurrency';
    CN_USER_VATSHIPPING = 'VATShipping';
    CN_USER_TOTALCURRENCY = 'TotalCurrency';
    CN_USER_TOTAL = 'Total';
    CN_USER_PAYMENT = 'Payment';
    CN_USER_DELIVERYMODE = 'DeliveryMode';
    CN_USER_SHAREITORDEREMAIL = 'ShareItOrderEMail';

type
  TFormTool = class(TForm)
    GroupBoxMain: TGroupBox;
    GroupBoxRegInfo: TGroupBox;
    EditName: TEdit;
    LabelName: TLabel;
    LabelEmail: TLabel;
    EditEmail: TEdit;
    EditVerCode: TEdit;
    LabelVerCode: TLabel;
    LabelRegNum: TLabel;
    EditRegNum: TEdit;
    ButtonRegister: TButton;
    ButtonRequest: TButton;
    ButtonSendMailVer: TButton;
    ListViewRegs: TListView;
    ButtonSendMailReg: TButton;
    ButtonRemove: TButton;
    ButtonAddMail: TButton;
    MemoClipboard: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    LabelNo: TLabel;
    LabelRegistrations: TLabel;
    StatusBar: TStatusBar;
    Homepage1: TMenuItem;
    MemoStrings: TMemo;
    ButtonFind: TButton;
    Options1: TMenuItem;
    Settings1: TMenuItem;
    CreateNewDatabase1: TMenuItem;
    N1: TMenuItem;
    ProjectManager1: TMenuItem;
    GroupBoxProjects: TGroupBox;
    ComboBoxSubVersion: TComboBox;
    Label1: TLabel;
    ListViewProjects: TListView;
    DataSource: TDataSource;
    ADOQuery: TADOQuery;
    ADOConnection: TADOConnection;
    ImageListProjectIconsSmall: TImageList;
    ImageListProjectIconsBig: TImageList;
    ButtonProjectManager: TButton;
    PopupMenuProjects: TPopupMenu;
    SwitchIconStyle1: TMenuItem;
    LabelComments: TLabel;
    MemoComments: TMemo;
    Splitter: TSplitter;
    ImportV1xDatabase1: TMenuItem;
    PopupMenuRegistrations: TPopupMenu;
    ViewRegistrationsComments1: TMenuItem;
    N2: TMenuItem;
    EditDefaultEmailTemplates1: TMenuItem;
    MemoDefaultEMailTemplateVersionCode: TMemo;
    MemoDefaultEMailTemplateRegistration: TMemo;
    ButtonEdit: TButton;
    MemoProcessClipboard: TMemo;
    Button1: TButton;
    Button2: TButton;
    PopupMenuTrayIcon: TPopupMenu;
    Exit2: TMenuItem;
    ShowWindow1: TMenuItem;
    TimerCheckIncomingMail: TTimer;
    MemoDefaultEMailTemplateVersionCodeError: TMemo;
    ask1: TMenuItem;
    CheckIncomingEmails1: TMenuItem;
    TimerDataBaseBackup: TTimer;
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonRegisterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListViewRegsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure ButtonRemoveClick(Sender: TObject);
    procedure ButtonSendMailVerClick(Sender: TObject);
    procedure ButtonSendMailRegClick(Sender: TObject);
    procedure ButtonRequestClick(Sender: TObject);
    procedure EditNameChange(Sender: TObject);
    procedure EditVerCodeClick(Sender: TObject);
    procedure EditEmailClick(Sender: TObject);
    procedure EditNameClick(Sender: TObject);
    procedure EditRegNumClick(Sender: TObject);
    procedure ButtonAddMailClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditNameKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditEmailKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditRegSeedKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditVerCodeSeedKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure ListViewRegsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Homepage1Click(Sender: TObject);
    procedure ListViewRegsChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure ButtonFindClick(Sender: TObject);
    procedure CreateNewDatabase1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure ProjectManager1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SwitchIconStyle1Click(Sender: TObject);
    procedure ListViewProjectsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure ImportV1xDatabase1Click(Sender: TObject);
    procedure ViewRegistrationsComments1Click(Sender: TObject);
    procedure PopupMenuRegistrationsPopup(Sender: TObject);
    procedure ComboBoxSubVersionChange(Sender: TObject);
    procedure EditDefaultEmailTemplates1Click(Sender: TObject);
    procedure ButtonEditClick(Sender: TObject);
    procedure ListViewRegsDblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ShowWindow1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure TimerCheckIncomingMailTimer(Sender: TObject);
    procedure CheckIncomingEmails1Click(Sender: TObject);
    procedure TimerDataBaseBackupTimer(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public declarations }
    STR_ERROR_NO_REG_SEED: String;
    STR_READY: String;
    STR_ERROR_LOADING: String;
    STR_ERROR_SAVING_DATA_FOLDER_SETTINGS: String;
    STR_ERROR_SAVING_SETTINGS: String;
    STR_REIGSTERED_FOR: String;
    STR_ERROR_DELETING: String;
    STR_SEND_VERSION_CODE: String;
    STR_SEND_REG_NUMBER: String;
    STR_ERROR_NO_VER_SEED: String;
    STR_ERROR_SAVING_PROJECT_NAMES: String;
    STR_ERROR_SAVING_PROJECT_SETTINGS: String;
    STR_ERROR_SAVING_2_FILE: String;
    STR_SETTINGS_SAVED: String;
    STR_NEW_PROJECT: String;
    STR_NEW_PROJECTS_NAME: String;
    STR_ERROR_CREATING_PATH: String;
    STR_NEW_SUBVERSION: String;
    STR_VERSION: String;
    STR_ERROR_PROJECT_EXISTS: String;
    STR_ADDED_NEW_PROJECT: String;
    STR_ADDED_NEW_SUBVERSION: String;
    STR_ERROR_NEW_SUBVERSION: String;
    STR_ERROR_WITH_SUBVERSION_FILE: String;
    STR_ERROR_LINE_SHOULD_START_WITH: String;
    STR_DELETE_PROJECT1: String;
    STR_DELETE_PROJECT2: String;
    STR_DELETE_PROJECT3: String;
    STR_SEARCH_NOT_FOUND: String;
    ProjectRegSeeds: Array of Double;
    ProjectVerCodeSeeds: Array of Double;
    TrayIconInfo: TTrayInfo;
    procedure LoadSettings;
    procedure SaveSettings;
    procedure SetProjectSettingsButtons;
    procedure CheckToUpgradeDataBaseToVersion3(DataBaseName: String);
    procedure CheckToUpgradeDataBaseToVersion4(DataBaseName: String);
    procedure CheckToUpgradeDataBaseToVersion5(DataBaseName: String);
    procedure CheckToUpgradeDataBaseToVersion6(DataBaseName: String);
    procedure CheckToUpgradeDataBaseToVersion7(DataBaseName: String);
    procedure ReloadProjects;
    procedure ReloadSubVersions;
    function SQLAddNewProjectRegistration(ProjectTableName: String; UserName: String; UserEmail: String; RegistrationTime: TDateTime; ShareItEMail: String): Integer;
    procedure SQLDeleteProjectRegistration(ProjectTableName: String; UserID: Integer);
    procedure LoadActiveProjectSettings;
    procedure SaveActiveProjectSettings;
    procedure LoadActiveProjectSubVersionSettings;
    procedure SaveActiveProjectSubVersionSettings;
    procedure ReloadRegistrations;
    procedure SortSubVersions;
    procedure SQLLoadDefaultEMailTemplates(var EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError: String);
    function SQLSetDefaultEMailTemplates(DataBaseName: String; Create: Boolean; EMailTemplateRegistrationText, EMailTemplateVersionCodeText, EMailTemplateVersionCodeErrorText: String): Boolean;
    procedure ReloadProjectsWithExceptionHandling;
    function AddNewRegistrant: Integer;
    procedure ReloadRegistration(Item: TListItem);
    procedure GetLastSubVersion(ProjectID: String; var SubVersionSeed: Double; var SubVersionName: String);
    function GetSubVersionSeed(ProjectID: String; SubVersionName: String; var SubVersionSeed: Double): Boolean;
  end;

    procedure SetColumns(ListView: TListView);

var
    FormTool: TFormTool;

    DataBaseFileName: String;
    DataBaseFileNameLog: String;
    DataBaseFileNameBackup: String;

implementation

Uses
    CommCtrl,
    //ProcMail,
    SearchWindow,
    CreateDatabase,
    Settings,
    ProjectManager,
    ImportV1Database, 
    RegistrationComments,
    SubVersionsSorting,
    EditEMailTemplates,
    UserDetails,
    Helper3delite,
    Helper3deliteWin,
    MailProcessing;

{$R *.dfm}

procedure TFormTool.ButtonCloseClick(Sender: TObject);
begin
	Close;
end;

procedure TFormTool.ButtonRegisterClick(Sender: TObject);
//var
    //UserID: Integer;
begin
    if ComboBoxSubVersion.ItemIndex = -1 then begin
        MessageDlg('Error: No sub version selected!', mtError, [mbOk], 0);
        Exit;
    end;
    try
        if StrToFloat(ListViewProjects.Selected.SubItems[2]) = 0
            then raise Exception.Create(STR_ERROR_NO_REG_SEED);
    except
        StatusBar.Panels[0].Text := STR_ERROR_NO_VER_SEED;
        Exit;
    end;

    //* Add new registration
    AddNewRegistrant;

    ReloadRegistrations;

    StatusBar.Panels[0].Text := STR_READY;
end;

function TFormTool.AddNewRegistrant: Integer;
begin
    //* Add new registration
    Result := SQLAddNewProjectRegistration(ListViewProjects.Selected.SubItems[1], EditName.Text, EditEMail.Text, Now, MemoProcessClipboard.Text);

	EditRegNum.Text := IntToStr(Result) + IntToStr(CalcRegNum(EditName.Text, EditEMail.Text, StrToFloat(ListViewProjects.Selected.SubItems[2])));

    ButtonRequest.Enabled := True;
    ButtonSendMailReg.Enabled := True;
    ButtonRequestClick(nil);
end;

procedure TFormTool.ViewRegistrationsComments1Click(Sender: TObject);
begin
    if Assigned(ListViewRegs.Selected) then begin
        FormRegistrationComments.MemoComments.Text := ListViewRegs.Selected.SubItems[3];
        FormRegistrationComments.ShowModal;
    end;
end;

procedure TFormTool.PopupMenuRegistrationsPopup(Sender: TObject);
begin
    if Assigned(ListViewRegs.Selected) then begin
        ViewRegistrationsComments1.Enabled := True;
    end else begin
        ViewRegistrationsComments1.Enabled := False;
    end;
end;

procedure TFormTool.ProjectManager1Click(Sender: TObject);
var
    ProjectIndex: Integer;
begin
    ProjectIndex := - 1;
    if Assigned(ListViewProjects.Selected) then begin
        ProjectIndex := ListViewProjects.Selected.Index;
    end;
    FormProjectManager.ShowModal;
    ReloadProjects;
    if ProjectIndex > - 1 then begin
        ListViewProjects.ItemIndex := ProjectIndex;
    end;
    {
    if Assigned(ListViewProjects.Selected) then begin
        ReloadSubVersions;
    end;
    }
end;

procedure TFormTool.LoadSettings;
var
  Ini: TIniFile;
begin
    Ini := TIniFile.Create(GetSettingsFileName);
    try
        Left := Ini.ReadInteger('Window', 'Left', Left);
        Top := Ini.ReadInteger('Window', 'Top', Top);
        Width := Ini.ReadInteger('Window', 'Width', Width);
        Height := Ini.ReadInteger('Window', 'Height', Height);
        if Ini.ReadString('Window', 'ProjectsStyle', 'vsIcon') = 'vsIcon' then begin
            ListViewProjects.ViewStyle := vsIcon;
        end;
        GroupBoxProjects.Height := Ini.ReadInteger('Window', 'ProjectsPanelHeight', GroupBoxProjects.Height);

        DataBaseFileName := Ini.ReadString('Backup', 'Data base file name', '');
        DataBaseFileNameLog := Ini.ReadString('Backup', 'Data base file name log', '');
        DataBaseFileNameBackup := Ini.ReadString('Backup', 'Data base file backup folder', '');

    finally
        Ini.Free;
    end;
end;

procedure TFormTool.LoadActiveProjectSettings;
var
    Ini: TIniFile;
    Index: Integer;
begin
    Ini := TIniFile.Create(GetSettingsFileName);
    try
        Index := Ini.ReadInteger('Settings', 'CurrentProject', -1);
    finally
        Ini.Free;
    end;
    if Index > -1 then begin
        if Index < ListViewProjects.Items.Count then begin
            ListViewProjects.Items.Item[Index].Selected := True;
        end;
    end;
end;

procedure TFormTool.SaveActiveProjectSettings;
var
    Ini: TIniFile;
    Index: Integer;
begin
    Index := -1;
    if Assigned(ListViewProjects.Selected) then begin
        Index := ListViewProjects.Selected.Index;
    end;
    Ini := TIniFile.Create(GetSettingsFileName);
    try
        Ini.WriteInteger('Settings', 'CurrentProject', Index);
    finally
        Ini.Free;
    end;
end;

procedure TFormTool.LoadActiveProjectSubVersionSettings;
var
    Ini: TIniFile;
    Index: Integer;
begin
    Ini := TIniFile.Create(GetSettingsFileName);
    try
        Index := Ini.ReadInteger('Settings', 'CurrentProjectSubVersion', -1);
    finally
        Ini.Free;
    end;
    if Index > -1 then begin
        if Index < ComboBoxSubVersion.Items.Count then begin
            ComboBoxSubVersion.ItemIndex := Index;
        end;
    end;
end;

procedure TFormTool.SaveActiveProjectSubVersionSettings;
var
    Ini: TIniFile;
    Index: Integer;
begin
    Index := ComboBoxSubVersion.ItemIndex;
    Ini := TIniFile.Create(GetSettingsFileName);
    try
        Ini.WriteInteger('Settings', 'CurrentProjectSubVersion', Index);
    finally
        Ini.Free;
    end;
end;

procedure TFormTool.SaveSettings;
var
  Ini: TIniFile;
  FileName: String;
  Success: Boolean;
begin
    Success := False;
    repeat
        try
            FileName := GetSettingsFileName;
            Ini := TIniFile.Create(FileName);
            try
                Ini.WriteInteger('Window', 'Left', Left);
                Ini.WriteInteger('Window', 'Top', Top);
                Ini.WriteInteger('Window', 'Width', Width);
                Ini.WriteInteger('Window', 'Height', Height);
                if ListViewProjects.ViewStyle = vsIcon then begin
                    Ini.WriteString('Window', 'ProjectsStyle', 'vsIcon');
                end else begin
                    Ini.WriteString('Window', 'ProjectsStyle', 'vsReport');
                end;
                Ini.WriteInteger('Window', 'ProjectsPanelHeight', GroupBoxProjects.Height);
            finally
                Ini.Free;
            end;
            Success := True;
        except
            if MessageDlg(STR_ERROR_SAVING_SETTINGS + (#13#10)
                + FileName
                , mtError, [mbOK, mbRetry], 0) = mrOK
                then Success := True;
        end;
    until Success;
end;

procedure TFormTool.FormCreate(Sender: TObject);
begin
    //* Get current language strings
    STR_ERROR_NO_REG_SEED := MemoStrings.Lines[0];
    STR_READY := MemoStrings.Lines[1];
    STR_ERROR_LOADING := MemoStrings.Lines[2];
    STR_ERROR_SAVING_DATA_FOLDER_SETTINGS := MemoStrings.Lines[3];
    STR_ERROR_SAVING_SETTINGS := MemoStrings.Lines[4];
    STR_REIGSTERED_FOR := MemoStrings.Lines[5];
    STR_ERROR_DELETING := MemoStrings.Lines[6];
    STR_SEND_VERSION_CODE := MemoStrings.Lines[7];
    STR_SEND_REG_NUMBER := MemoStrings.Lines[8];
    STR_ERROR_NO_VER_SEED := MemoStrings.Lines[9];
    STR_ERROR_SAVING_PROJECT_NAMES := MemoStrings.Lines[10];
    STR_ERROR_SAVING_PROJECT_SETTINGS := MemoStrings.Lines[11];
    STR_ERROR_SAVING_2_FILE := MemoStrings.Lines[12];
    STR_SETTINGS_SAVED := MemoStrings.Lines[13];
    STR_NEW_PROJECT := MemoStrings.Lines[14];
    STR_NEW_PROJECTS_NAME := MemoStrings.Lines[15];
    STR_ERROR_CREATING_PATH := MemoStrings.Lines[16];
    STR_NEW_SUBVERSION := MemoStrings.Lines[17];
    STR_VERSION := MemoStrings.Lines[18];
    STR_ERROR_PROJECT_EXISTS := MemoStrings.Lines[19];
    STR_ADDED_NEW_PROJECT := MemoStrings.Lines[20];
    STR_ADDED_NEW_SUBVERSION := MemoStrings.Lines[21];
    STR_ERROR_NEW_SUBVERSION := MemoStrings.Lines[22];
    STR_ERROR_WITH_SUBVERSION_FILE := MemoStrings.Lines[23];
    STR_ERROR_LINE_SHOULD_START_WITH := MemoStrings.Lines[24];
    STR_DELETE_PROJECT1 := MemoStrings.Lines[25];
    STR_DELETE_PROJECT2 := MemoStrings.Lines[26];
    STR_DELETE_PROJECT3 := MemoStrings.Lines[27];
    STR_SEARCH_NOT_FOUND := MemoStrings.Lines[28];

    LoadSettings;

    StatusBar.Panels[1].Text := 'Registration Tool ' + GetFileVersionStr(Application.ExeName);

    InitializeTrayIcon(TrayIconInfo, Self.Handle, MSG_TRAY_ICON);
    AdjustTrayIcon(TrayIconInfo, Application.Icon.Handle, 'Registration Tool is running.', NIM_ADD);

    SetColumns(ListViewProjects);

    //if VersionUpdate.IsNewerVersionAvailable then begin
    //    VersionUpdate.IsNewerVersionAvailableDialog;
    //end;

    Screen.Cursor := crAppStart;
    try
        try
            CheckToUpgradeDataBaseToVersion3(FormSettings.EditDatabaseNameToUse.Text);
            CheckToUpgradeDataBaseToVersion4(FormSettings.EditDatabaseNameToUse.Text);
            CheckToUpgradeDataBaseToVersion5(FormSettings.EditDatabaseNameToUse.Text);
            CheckToUpgradeDataBaseToVersion6(FormSettings.EditDatabaseNameToUse.Text);
            CheckToUpgradeDataBaseToVersion7(FormSettings.EditDatabaseNameToUse.Text);

            //SQLSetDefaultEMailTemplates(DataBaseName, True, MemoDefaultEMailTemplateRegistration.Text, MemoDefaultEMailTemplateVersionCode.Text, MemoDefaultEMailTemplateVersionCodeError.Text);

            try
                FormSettings.LoadSettingsFromDataBase;
            except
                on E: Exception do begin
                    MessageDlg('Error while loading settings: ' + E.Message, mtError, [mbOk], 0);
                end;
            end;

            ReloadProjects;
            LoadActiveProjectSettings;
            if Assigned(ListViewProjects.Selected) then begin
                ReloadSubVersions;
                LoadActiveProjectSubVersionSettings;
            end;
        except
            on E: Exception do begin
                MessageDlg('Error: ' + E.Message, mtError, [mbOk], 0);
            end;
        end;
    finally
        Screen.Cursor := crDefault;
    end;

    SetProjectSettingsButtons;

    TimerCheckIncomingMail.Interval := FormSettings.SpinEditScanTimerMins.Value * 60 * 1000;
    if ParamStr(1) = '-startminimized' then begin
        TimerCheckIncomingMail.Enabled := True;
    end;

end;

procedure TFormTool.ListViewRegsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
    SetProjectSettingsButtons;
	if NOT Selected then begin
        ButtonRequest.Enabled := False;
        Exit;
    end;
    ButtonRequest.Enabled := False;
    ButtonSendMailVer.Enabled := False;
    ButtonSendMailReg.Enabled := False;
    ButtonRegister.Enabled := True;
    EditVerCode.Clear;
    EditRegNum.Clear;
    EditName.Text := ListViewRegs.Selected.SubItems[0];
    EditEmail.Text := ListViewRegs.Selected.SubItems[1];
    MemoComments.Text := ListViewRegs.Selected.SubItems[3];
    EditRegNum.Text := ListViewRegs.Selected.Caption + IntToStr(CalcRegNum(EditName.Text, EditEMail.Text, StrToFloat(ListViewProjects.Selected.SubItems[2])));
    ButtonRequestClick(nil);
    ButtonRequest.Enabled := True;
end;

procedure TFormTool.ButtonRemoveClick(Sender: TObject);
var
    DialogResult: Integer;
begin
    if (ListViewRegs.Selected = nil)
    OR (ListViewRegs.SelCount = 0)
        then Exit;
    DialogResult := MessageDlg('Are you sure you want to delete registration:' + #13#10
         + ListViewRegs.Selected.SubItems[0] + ' (' + ListViewRegs.Selected.SubItems[1] + ')',
         mtConfirmation, [mbYes, mbCancel], 0);
    if DialogResult = mrYes then begin
        SQLDeleteProjectRegistration(ListViewProjects.Selected.SubItems[1], StrToInt(ListViewRegs.Selected.Caption));
        MessageDlg('Successfully deleted registration: '
            + ListViewRegs.Selected.SubItems[0] + ' (' + ListViewRegs.Selected.SubItems[1] + ')',
            mtConfirmation, [mbOk], 0);
        ReloadRegistrations;
    end;
end;

procedure TFormTool.ButtonSendMailVerClick(Sender: TObject);
var
    StrBody, StrEmail: String;
    EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError: String;
begin

	if MessageDlg(STR_SEND_REG_NUMBER , mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

        FormProjectManager.SQLLoadProjectEMailTemplates(StrToInt(ListViewProjects.Selected.SubItems[0]), EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError);

        if EMailTemplateRegistration = '' then begin
            SQLLoadDefaultEMailTemplates(EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError);
        end;

        //* No template found (should not happen)
        if EMailTemplateVersionCode = '' then begin

            StrBody := 'Name: ' + EditName.Text + #13#10
                + 'E-mail: ' + EditEMail.Text + #13#10
                //+ 'Your Registration number: ' + EditRegNum.Text + #13#10
                + 'Your Version code: ' + EditVerCode.Text + #13#10
                + ListViewProjects.Selected.Caption + ' Version: ' + ComboBoxSubVersion.Text;

            //StrBody := StringReplace(StrBody, '&&', '&', [rfReplaceAll]);
            //StrBody := StringReplace(StrBody, '&', '%26', [rfReplaceAll]);

        //* Fill in tamplete varialbes
        end else begin
            StrBody := EMailTemplateVersionCode;
            StrBody := StringReplace(StrBody, '%PROGRAMNAME%', ListViewProjects.Selected.Caption, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%PROGRAMVERSION%', ComboBoxSubVersion.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONNAME%', EditName.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONEMAIL%', EditEMail.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONNUMBER%', EditRegNum.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONVERSIONCODE%', EditVerCode.Text, [rfReplaceAll]);
        end;

        MemoClipboard.Text := StrBody;
        Clipboard;
        MemoClipboard.SelectAll;
        MemoClipboard.CopyToClipboard;

        StrBody := URLEncode(StrBody , False);

        StrEmail := 'mailto:' + EditEMail.Text + '?subject=' + URLEncode(ListViewProjects.Selected.Caption, False) + ' - Your Version Code' + '&body=' + StrBody;

        ShellExecute(Handle,'open', PChar(StrEmail), nil, nil, SW_SHOWNORMAL);
	end;

end;

procedure TFormTool.ButtonSendMailRegClick(Sender: TObject);
var
    StrBody, StrEmail: String;
    EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError: String;
begin

	if MessageDlg(STR_SEND_REG_NUMBER , mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

        FormProjectManager.SQLLoadProjectEMailTemplates(StrToInt(ListViewProjects.Selected.SubItems[0]), EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError);

        if EMailTemplateRegistration = '' then begin
            SQLLoadDefaultEMailTemplates(EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError);
        end;

        //* No template found (should not happen)
        if EMailTemplateRegistration = '' then begin

            StrBody := 'Name: ' + EditName.Text + #13#10
                + 'E-mail: ' + EditEMail.Text + #13#10
                + 'Your Registration number: ' + EditRegNum.Text + #13#10
                + 'Your Version code: ' + EditVerCode.Text + #13#10
                + ListViewProjects.Selected.Caption + ' Version: ' + ComboBoxSubVersion.Text;

            //StrBody := StringReplace(StrBody, '&&', '&', [rfReplaceAll]);
            //StrBody := StringReplace(StrBody, '&', '%26', [rfReplaceAll]);

        //* Fill in tamplete varialbes
        end else begin
            StrBody := EMailTemplateRegistration;
            StrBody := StringReplace(StrBody, '%PROGRAMNAME%', ListViewProjects.Selected.Caption, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%PROGRAMVERSION%', ComboBoxSubVersion.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONNAME%', EditName.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONEMAIL%', EditEMail.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONNUMBER%', EditRegNum.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%REGISTRATIONVERSIONCODE%', EditVerCode.Text, [rfReplaceAll]);
            StrBody := StringReplace(StrBody, '%PROGRAMDOWNLOADURL%', ListViewProjects.Selected.SubItems[3], [rfReplaceAll]);
        end;

        MemoClipboard.Text := StrBody;
        Clipboard;
        MemoClipboard.SelectAll;
        MemoClipboard.CopyToClipboard;

        StrBody := URLEncode(StrBody , False);

        StrEmail := 'mailto:' + EditEMail.Text + '?subject=' + URLEncode(ListViewProjects.Selected.Caption, False) + ' - Your Registration Number' + '&body=' + StrBody;

        ShellExecute(Handle,'open', PChar(StrEmail), nil, nil, SW_SHOWNORMAL);
	end;
    
end;

procedure TFormTool.ButtonRequestClick(Sender: TObject);
var
    Index: Integer;
begin
    try
        if ComboBoxSubVersion.ItemIndex = -1
            then raise Exception.Create(STR_ERROR_NO_VER_SEED);
    except
        on E: Exception do begin
            //MessageDlg(E.Message, mtError, [mbOk], 0);
            StatusBar.Panels[0].Text := STR_ERROR_NO_VER_SEED;
            Exit;
        end;
    end;
    Index := Integer(ComboBoxSubVersion.Items.Objects[ComboBoxSubVersion.ItemIndex]);
    EditVerCode.Text := IntToStr(CalcVerCode(StrToInt64(EditRegNum.Text), ProjectVerCodeSeeds[Index]));
    ButtonSendMailVer.Enabled := True;
    ButtonSendMailReg.Enabled := True;
    StatusBar.Panels[0].Text := STR_READY;
end;

procedure TFormTool.EditNameChange(Sender: TObject);
begin
	if (EditName.Text <> '')
    AND (EditEmail.Text <> '')
    then begin
        ButtonRegister.Enabled := True;
    end else begin
        ButtonRegister.Enabled := False;
    end;
end;

procedure TFormTool.EditVerCodeClick(Sender: TObject);
begin
	EditVerCode.CopyToClipboard;
end;

procedure TFormTool.EditDefaultEmailTemplates1Click(Sender: TObject);
var
    EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError: String;
begin
    SQLLoadDefaultEMailTemplates(EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError);
    FormEditEMailTemplates.MemoRegistrationEMailTemplate.Text := EMailTemplateRegistration;
    FormEditEMailTemplates.MemoVersionCodeEMailTemplate.Text := EMailTemplateVersionCode;
    FormEditEMailTemplates.MemoVersionCodeErrorEMailTemplate.Text := EMailTemplateVersionCodeError;
    case FormEditEMailTemplates.ShowModal of
        mrOk: begin
            if SQLSetDefaultEMailTemplates(FormSettings.EditDatabaseNameToUse.Text, False, FormEditEMailTemplates.MemoRegistrationEMailTemplate.Text, FormEditEMailTemplates.MemoVersionCodeEMailTemplate.Text, FormEditEMailTemplates.MemoVersionCodeErrorEMailTemplate.Text) then begin
                MessageDlg('New e-mail templates saved.', mtInformation, [mbOk], 0);
            end;
        end;
    end;
end;

procedure TFormTool.EditEmailClick(Sender: TObject);
begin
	EditEMail.CopyToClipboard;
end;

procedure TFormTool.EditNameClick(Sender: TObject);
begin
	EditName.CopyToClipboard;
end;

procedure TFormTool.EditRegNumClick(Sender: TObject);
begin
	EditRegNum.CopyToClipboard;
end;

procedure TFormTool.ButtonEditClick(Sender: TObject);
begin
    if (ListViewRegs.Selected = nil)
    OR (ListViewRegs.SelCount = 0)
        then Exit;
    FormRegistrantDetails.ProjectName := ListViewProjects.Selected.Caption;
    FormRegistrantDetails.LoadRegistration(ListViewProjects.Selected.SubItems[1], ListViewRegs.Selected.Caption);
    case FormRegistrantDetails.ShowModal of
        mrOk: begin
            FormRegistrantDetails.SQLUpdateRegistration(ListViewProjects.Selected.SubItems[1]);
            ReloadRegistration(ListViewRegs.Selected);
        end;
    end;
end;

procedure TFormTool.Button1Click(Sender: TObject);
begin
    TimerCheckIncomingMail.Enabled := True;
    Hide;
end;

procedure TFormTool.Button2Click(Sender: TObject);
begin
    Application.Terminate;
end;

procedure TFormTool.ButtonAddMailClick(Sender: TObject);
var
    NewRegistrantID: Integer;
begin
	MemoProcessClipboard.Clear;
    MemoProcessClipboard.PasteFromClipboard;
    if MemoProcessClipboard.Lines.Count < 2 then begin
        MessageDlg('Clipboard is empty.', mtWarning, [mbCancel], 0);
        Exit;
    end;
    FormRegistrantDetails.Clear;
    FormRegistrantDetails.ProjectName := ListViewProjects.Selected.Caption;
    FormRegistrantDetails.ProcessShareItEMail(MemoProcessClipboard.Lines);
    case FormRegistrantDetails.ShowModal of
        mrOK: begin
         	EditName.Text := FormRegistrantDetails.EditCustomerRegistrationName.Text;
            EditEMail.Text := FormRegistrantDetails.EditCustomerEMail.Text;
            NewRegistrantID := AddNewRegistrant;
            FormRegistrantDetails.EditCustomerID.Text := IntToStr(NewRegistrantID);
            FormRegistrantDetails.SQLUpdateRegistration(ListViewProjects.Selected.SubItems[1]);
            ReloadRegistrations;
            ButtonSendMailRegClick(nil);
        end;
    end;
end;

procedure TFormTool.ComboBoxSubVersionChange(Sender: TObject);
begin
    SetProjectSettingsButtons;
end;

procedure TFormTool.CreateNewDatabase1Click(Sender: TObject);
begin
    FormCreateDatabase.ShowModal;
end;

procedure TFormTool.Exit1Click(Sender: TObject);
begin
    Close;
end;

procedure TFormTool.Exit2Click(Sender: TObject);
begin
    Application.Terminate;
end;

procedure TFormTool.FormDestroy(Sender: TObject);
begin
    SaveSettings;
    SaveActiveProjectSettings;
    SaveActiveProjectSubVersionSettings;
    AdjustTrayIcon(TrayIconInfo, Application.Icon.Handle, 'Quiting...', NIM_DELETE);
end;

procedure TFormTool.SetProjectSettingsButtons;
begin
    if NOT Assigned(ListViewProjects.Selected) then begin
        ButtonAddMail.Enabled := False;
        LabelName.Enabled := False;
        LabelEmail.Enabled := False;
        LabelVerCode.Enabled := False;
        LabelRegNum.Enabled := False;
        EditName.Enabled := False;
        EditEmail.Enabled := False;
        EditVerCode.Enabled := False;
        EditRegNum.Enabled := False;
        ButtonRequest.Enabled := False;
        ButtonRegister.Enabled := False;
        ButtonSendMailVer.Enabled := False;
        ButtonSendMailReg.Enabled := False;
    end else begin
        if ComboBoxSubVersion.ItemIndex > -1 then begin
            ButtonAddMail.Enabled := True;
        end else begin
            ButtonAddMail.Enabled := False;
        end;
        LabelName.Enabled := True;
        LabelEmail.Enabled := True;
        LabelVerCode.Enabled := True;
        LabelRegNum.Enabled := True;
        EditName.Enabled := True;
        EditEmail.Enabled := True;
        EditVerCode.Enabled := True;
        EditRegNum.Enabled := True;
    end;
    if Assigned(ListViewRegs.Selected) then begin
        ButtonEdit.Enabled := True;
        ButtonRemove.Enabled := True;
    end else begin
        ButtonEdit.Enabled := False;
        ButtonRemove.Enabled := False;
    end;
    if ListViewRegs.Items.Count > 0 then begin
        ButtonFind.Enabled := True;
    end else begin
        ButtonFind.Enabled := False;
    end;
end;

procedure TFormTool.Settings1Click(Sender: TObject);
begin
    FormSettings.ShowModal;
end;

procedure TFormTool.ShowWindow1Click(Sender: TObject);
begin
    Show;
end;

procedure TFormTool.SwitchIconStyle1Click(Sender: TObject);
begin
    if ListViewProjects.ViewStyle = vsReport then begin
        ListViewProjects.ViewStyle := vsIcon;
    end else begin
        ListViewProjects.ViewStyle := vsReport;
        SetColumns(ListViewProjects);
        ListViewProjects.Invalidate;
        ListViewProjects.Update;
    end;

end;

procedure TFormTool.TimerCheckIncomingMailTimer(Sender: TObject);
begin
    CheckAndProcessIncomingMail;
end;

procedure TFormTool.TimerDataBaseBackupTimer(Sender: TObject);
var
    NewFolder: String;
begin
    TimerDataBaseBackup.Enabled := False;
    if FileExists(DataBaseFileName)
    AND DirectoryExists(DataBaseFileNameBackup)
    then begin
        NewFolder := IncludeTrailingPathDelimiter(DataBaseFileNameBackup) + StrConvertToFileName(DateTimeToStr(Now));
        ForceDirectories(NewFolder);
        CopyFile(PChar(DataBaseFileName), PChar(IncludeTrailingPathDelimiter(NewFolder) + ExtractFileName(DataBaseFileName)), False);
        CopyFile(PChar(DataBaseFileNameLog), PChar(IncludeTrailingPathDelimiter(NewFolder) + ExtractFileName(DataBaseFileNameLog)), False);
        if FormSettings.CheckBoxLogDebug.Checked then begin
            LogStrings(FormSettings.EditLogFileName.Text, DateTimeToStr(Now) + ' COPY: ' + IncludeTrailingPathDelimiter(NewFolder) + ExtractFileName(DataBaseFileName));
        end;
    end;
end;

procedure TFormTool.EditNameKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if Key = VK_RETURN
        then EditEmail.SetFocus;
end;

procedure TFormTool.EditEmailKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if Key = VK_RETURN
        then ButtonRegisterClick(Sender);
end;

procedure TFormTool.EditRegSeedKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    //if Key = VK_RETURN
    //    then EditVerCodeSeed.SetFocus;
end;

procedure TFormTool.EditVerCodeSeedKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    {
    if Key = VK_RETURN then begin
        ButtonSaveChanges.Font.Color := clRed;
        ButtonSaveChanges.SetFocus;
    end;
    }
end;

procedure TFormTool.FormResize(Sender: TObject);
begin
    StatusBar.Panels[0].Width := StatusBar.Width - 300;
end;

procedure TFormTool.FormShow(Sender: TObject);
begin
    //ReloadProjects;
end;

procedure TFormTool.ListViewRegsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if Key = VK_Delete
        then ButtonRemoveClick(Sender);
end;

procedure TFormTool.Homepage1Click(Sender: TObject);
begin
    ShellExecute(Handle, 'open', PChar(WWW_TREGISTRATION), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormTool.ImportV1xDatabase1Click(Sender: TObject);
begin
    FormImport.LabelProgress.Caption := 'Ready.';
    FormImport.ShowModal;
    ReloadProjects;
end;

procedure TFormTool.ListViewProjectsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
    if Selected then begin
        ReloadSubversions;
        if ComboBoxSubVersion.Items.Count > 0 then begin
            ComboBoxSubVersion.ItemIndex := ComboBoxSubVersion.Items.Count - 1;
        end;
        ReloadRegistrations;
    end else begin
        ComboBoxSubVersion.Items.Clear;
        ListViewRegs.Clear;
    end;
    SetProjectSettingsButtons;
end;

procedure TFormTool.ListViewRegsChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
    LabelRegistrations.Caption := IntToStr(ListViewRegs.Items.Count);
end;

procedure TFormTool.ListViewRegsDblClick(Sender: TObject);
begin
    if Assigned(ListViewRegs.Selected) then begin
        ButtonEditClick(Sender);
    end;
end;

procedure TFormTool.ButtonFindClick(Sender: TObject);
begin
    if NOT Assigned(FormSearch)
        then Application.CreateForm(TFormSearch, FormSearch);
    FormSearch.Show;
end;

procedure SetColumns(ListView: TListView);
var
    Column: TLVColumn;
begin
    Column.mask := LVCF_ORDER {OR LVCF_WIDTH};

    ListView_GetColumn(ListView.Handle, 0, Column);
    Column.iOrder := 1;
    ListView_SetColumn(ListView.Handle, 0, Column);
    //ListView.Columns[0].Width := 400;

    ListView_GetColumn(ListView.Handle, 1, Column);
    Column.iOrder := 0;
    ListView_SetColumn(ListView.Handle, 1, Column);
    //ListView.Columns[1].Width := 45;
end;

procedure TFormTool.CheckIncomingEmails1Click(Sender: TObject);
begin
    CheckAndProcessIncomingMail;
end;

procedure TFormTool.CheckToUpgradeDataBaseToVersion3(DataBaseName: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;

    try
        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if projects table exists
        ADOQuery.SQL.Add('SELECT table_name');
        ADOQuery.SQL.Add('FROM information_schema.tables');
        ADOQuery.SQL.Add('WHERE table_name = ''' + TN_PROJECTS + '''');

        ADOQuery.Open;

        //* No existing table found, exit
        if DataSource.DataSet.IsEmpty then begin
            Exit;
        end;

        //* Check if there is a settings table, if no create it
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if settings table exists
        ADOQuery.SQL.Add('SELECT table_name');
        ADOQuery.SQL.Add('FROM information_schema.tables');
        ADOQuery.SQL.Add('WHERE table_name = ''' + TN_SETTINGS + '''');

        ADOQuery.Open;

        //* No settings table found, create it
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            //* Create a new table
            ADOQuery.SQL.Add('CREATE TABLE "' + TN_SETTINGS + '"');
            ADOQuery.SQL.Add('(');
            ADOQuery.SQL.Add(CN_SETTINGS_ID + ' INT IDENTITY(1,1) NOT NULL,');
            //* Add the 2 specified columns as unicode type, max. 50 characters
            ADOQuery.SQL.Add(CN_SETTINGS_VERSION + ' INT NOT NULL,');
            //ADOQuery.SQL.Add(CN_PROJECT_TABLENAME + ' VARCHAR(255) NOT NULL,');
            //ADOQuery.SQL.Add(CN_PROJECT_REG_SEED + ' VARCHAR(255) NOT NULL,');
            //ADOQuery.SQL.Add(CN_PROJECT_ICON + ' VARBINARY(MAX),');
            ADOQuery.SQL.Add(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_REGISTRATION + ' NTEXT,');
            ADOQuery.SQL.Add(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE + ' NTEXT,');
            ADOQuery.SQL.Add('PRIMARY KEY (' + CN_SETTINGS_ID + ')');
            ADOQuery.SQL.Add(')');

            ADOQuery.ExecSql;

            //* Set default registration e-mail templates
            //SQLSetDefaultEMailTemplates(DataBaseName, True, MemoDefaultEMailTemplateRegistration.Text, MemoDefaultEMailTemplateVersionCode.Text, MemoDefaultEMailTemplateVersionCodeError.Text);
        end;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if TEMPLATE_REGISTRATION column exists
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_PROJECTS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_PROJECT_EMAIL_TEMPLATE_REGISTRATION + '''');

        ADOQuery.Open;

        //* No TEMPLATE_REGISTRATION column found, create it
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_PROJECTS + '" ADD "' + CN_PROJECT_EMAIL_TEMPLATE_REGISTRATION + '" NTEXT');
            ADOQuery.ExecSql;
        end;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
        //* Check if TEMPLATE_VERSIONCODE column exists
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_PROJECTS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE + '''');

        ADOQuery.Open;

        //* No TEMPLATE_VERSIONCODE column found, create it
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_PROJECTS + '" ADD "' + CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE + '" NTEXT');
            ADOQuery.ExecSql;
        end;
    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;
end;

procedure TFormTool.CheckToUpgradeDataBaseToVersion4(DataBaseName: String);
var
    ProjectTableNames: TStrings;
    ProjectIndex: Integer;
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;

    try
        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if projects data exists
        ADOQuery.SQL.Add('SELECT ' + CN_PROJECT_TABLENAME + ' FROM "' + TN_PROJECTS + '"');

        ADOQuery.Open;

        //* No existing table found, exit
        if DataSource.DataSet.IsEmpty then begin
            Exit;
        end;

        //* Check all existing projects, if no v4 columns, create it
        ProjectTableNames := TStringList.Create;
        try
            //* Extract all existing table names to a list
            DataSource.DataSet.First;
            while NOT DataSource.DataSet.Eof do begin
                ProjectTableNames.Append(DataSource.DataSet.FieldByName(CN_PROJECT_TABLENAME).AsString);
                DataSource.DataSet.Next;
            end;
            //* Check to update all project tables
            for ProjectIndex := 0 to ProjectTableNames.Count - 1 do begin

                ADOQuery.SQL.Clear;

                //* Set to use our new database (specified by name)
                ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

                //* Check if CN_USER_SALUTATION column exists, if not, then not a V4 table add all V4 columns
                ADOQuery.SQL.Add('SELECT COLUMN_NAME');
                ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
                ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + ProjectTableNames[ProjectIndex] + '''');
                ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_USER_SALUTATION + '''');

                ADOQuery.Open;

                //* No USER_SALUTATION column found, create all V4 columns
                if DataSource.DataSet.IsEmpty then begin
                    ADOQuery.SQL.Clear;
                    //* Rename 'Comments' column to 'ShareItOrderEMail'
                    ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
                    //ADOQuery.SQL.Add('ALTER TABLE "' + ProjectTableNames[ProjectIndex] + '"');
                    //ADOQuery.SQL.Add('RENAME COLUMN ' + CN_USER_COMMENTS + ' TO ' + CN_USER_SHAREITORDEREMAIL + '');

                    ADOQuery.SQL.Add('EXEC sp_RENAME ''' + ProjectTableNames[ProjectIndex] + '.' + CN_USER_COMMENTS + ''', ''' + CN_USER_SHAREITORDEREMAIL + ''', ''COLUMN''');

                    ADOQuery.ExecSql;
                    ADOQuery.SQL.Clear;
                    //* create all V4 columns
                    ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
                    ADOQuery.SQL.Add('ALTER TABLE "' + ProjectTableNames[ProjectIndex] + '" ADD');
                    ADOQuery.SQL.Add('"' + CN_USER_SALUTATION + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_TITLE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_LASTNAME + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_FIRSTNAME + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_COMPANY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_CONTACTNAME + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_ADDRESS + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_CITY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_FULLCITY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_COUNTRY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_POSTALCODE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_STATEPROVINCE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_TELEPHONE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_MOBILEPHONE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_FAX + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_HOMEPAGE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_NEWSLETTER + '" BIT,');
                    ADOQuery.SQL.Add('"' + CN_USER_VATID + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_NOOFLICENSES + '" INT,');
                    ADOQuery.SQL.Add('"' + CN_USER_LANGUAGE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_SHAREITREFNO + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_RESELLER + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_PROMOTIONNAME + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_NETSALESCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_NETSALES + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_NETDISCOUNTCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_NETDISCOUNT + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_COLLECTEDVATCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_COLLECTEDVAT + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_SHIPPINGCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_SHIPPING + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_VATSHIPPINGCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_VATSHIPPING + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_TOTALCURRENCY + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_TOTAL + '" MONEY,');
                    ADOQuery.SQL.Add('"' + CN_USER_PAYMENT + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_DELIVERYMODE + '" NVARCHAR(255),');
                    ADOQuery.SQL.Add('"' + CN_USER_COMMENTS + '" NTEXT');

                    ADOQuery.ExecSql;

                    //* Fill in new columns from share-it e-mail string
                    ADOQuery.SQL.Clear;
                    ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
                    //* Get share-it e-mail data
                    ADOQuery.SQL.Add('SELECT * FROM ' + ProjectTableNames[ProjectIndex]);
                    ADOQuery.Open;
                    //* Try to update registrant details
                    DataSource.DataSet.First;
                    while NOT DataSource.DataSet.Eof do begin
                        FormRegistrantDetails.Clear;
                        MemoProcessClipboard.Text := DataSource.DataSet.FieldByName(CN_USER_SHAREITORDEREMAIL).AsWideString;
                        if MemoProcessClipboard.Text <> '' then begin
                            FormRegistrantDetails.EditCustomerID.Text := DataSource.DataSet.FieldByName(CN_USER_ID).AsWideString;
                            FormRegistrantDetails.ProcessShareItEMail(MemoProcessClipboard.Lines);
                            FormRegistrantDetails.EditCustomerRegistrationName.Text := DataSource.DataSet.FieldByName(CN_USER_REGISTRATIONNAME).AsWideString;
                            FormRegistrantDetails.EditCustomerEmail.Text := DataSource.DataSet.FieldByName(CN_USER_EMAIL).AsString;
                            FormRegistrantDetails.DateTimePickerRegistrationDate.DateTime := DataSource.DataSet.FieldByName(CN_USER_REG_TIME).AsDateTime;
                            FormRegistrantDetails.SQLUpdateRegistration(ProjectTableNames[ProjectIndex]);
                        end;
                        DataSource.DataSet.Next;
                    end;
                end;
            end;
        finally
            FreeAndNil(ProjectTableNames);
        end;
    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;
end;

procedure TFormTool.CheckToUpgradeDataBaseToVersion5(DataBaseName: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;

    try
        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if projects table exists
        ADOQuery.SQL.Add('SELECT table_name');
        ADOQuery.SQL.Add('FROM information_schema.tables');
        ADOQuery.SQL.Add('WHERE table_name = ''' + TN_PROJECTS + '''');

        ADOQuery.Open;

        //* No existing table found, exit
        if DataSource.DataSet.IsEmpty then begin
            Exit;
        end;

        //*----------------
     (*
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

        //* Check if TEMPLATE_REGISTRATION column exists in TN_SETTINGS
        //ADOQuery.SQL.Add('SHOW INDEX FROM ' + TN_PROJECTS_SUBVERSION);
        ADOQuery.SQL.Add('ALTER TABLE ' + TN_PROJECTS_SUBVERSION + ' DROP UNIQUE (' + CN_SUBVERSION_NAME + ')');

        ADOQuery.ExecSql;
     *)
        //ADOQuery.Open;    ALTER TABLE Persons DROP CONSTRAINT uc_PersonID

        {
        if NOT DataSource.DataSet.IsEmpty then begin
            DataSource.DataSet.First;
            ADOQuery.SQL.Clear;
            ADOQuery.SQL.Add('DROP INDEX ' + DataSource.DataSet.FieldByName('key_name').AsString + ' ON ' + TN_PROJECTS_SUBVERSION);
            ADOQuery.ExecSql;
        end;
        }

        //*---------------

        //* Check if there is a settings table, if no create it
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if settings table exists
        ADOQuery.SQL.Add('SELECT table_name');
        ADOQuery.SQL.Add('FROM information_schema.tables');
        ADOQuery.SQL.Add('WHERE table_name = ''' + TN_SETTINGS + '''');

        ADOQuery.Open;

        //* No settings table found, create it
        if DataSource.DataSet.IsEmpty then begin
            //* BAD
            Exit;
        end;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if TEMPLATE_REGISTRATION column exists in TN_SETTINGS
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_PROJECTS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_PROJECT_DOWNLOAD_URL + '''');

        ADOQuery.Open;

        //* No CN_PROJECT_DOWNLOAD_URL column found, create the new v5 column
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_PROJECTS + '" ADD');
            ADOQuery.SQL.Add('"' + CN_PROJECT_DOWNLOAD_URL + '" NTEXT');

            ADOQuery.ExecSql;
        end;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if TEMPLATE_REGISTRATION column exists in TN_SETTINGS
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_SETTINGS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_SETTINGS_EMAIL_CHECK_INTERVAL + '''');

        ADOQuery.Open;

        //* No CN_SETTINGS_EMAIL_CHECK_INTERVAL column found, create all new v5 columns
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_SETTINGS + '" ADD');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_CHECK_INTERVAL + '" INT,');
            //* Incoming
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_GUID + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_ItemName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_Active + '" BIT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_HostName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_Port + '" INT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_LoginName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_Password + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_Security + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_SSLMethod + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_ServerType + '" NVARCHAR(255),');
            //* Outgoing
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_GUID + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_ItemName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_Active + '" BIT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_HostName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_Port + '" INT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_LoginName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_Password + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_Security + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_SSLMethod + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_OUTGOING_ServerType + '" NVARCHAR(255),');
            //* Emails
            ADOQuery.SQL.Add('"' + CN_EMAIL_SENDER_ADDRESS + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_EMAIL_FORWARD_ADDRESS + '" NVARCHAR(255)');

            ADOQuery.ExecSql;

            //* Set default registration e-mail templates
            //SQLSetDefaultEMailTemplates(DataBaseName, True, MemoDefaultEMailTemplateRegistration.Text, MemoDefaultEMailTemplateVersionCode.Text, MemoDefaultEMailTemplateVersionCodeError.Text);

        end;

        ADOQuery.SQL.Clear;

    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;

end;

procedure TFormTool.CheckToUpgradeDataBaseToVersion6(DataBaseName: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;

    try
        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if projects table exists
        ADOQuery.SQL.Add('SELECT table_name');
        ADOQuery.SQL.Add('FROM information_schema.tables');
        ADOQuery.SQL.Add('WHERE table_name = ''' + TN_PROJECTS + '''');

        ADOQuery.Open;

        //* No existing table found, exit
        if DataSource.DataSet.IsEmpty then begin
            Exit;
        end;

        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if projects table exists
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_PROJECTS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE_ERROR + '''');

        ADOQuery.Open;

        //* No CN_PROJECT_DOWNLOAD_URL column found, create the new v5 column
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_PROJECTS + '" ADD');
            ADOQuery.SQL.Add('"' + CN_PROJECT_EMAIL_TEMPLATE_VERSIONCODE_ERROR + '" NTEXT');

            ADOQuery.ExecSql;
        end;


        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if TEMPLATE_REGISTRATION column exists in TN_SETTINGS
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_SETTINGS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + CN_EMAIL_SUPPORT_ADDRESS + '''');

        ADOQuery.Open;

        //* No CN_SETTINGS_EMAIL_CHECK_INTERVAL column found, create all new v5 columns
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_SETTINGS + '" ADD');
            //ADOQuery.SQL.Add('"' + CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE_ERROR + '" NTEXT,');
            //* Incoming version code requests
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active + '" BIT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port + '" INT,');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType + '" NVARCHAR(255),');

            //* Emails
            //ADOQuery.SQL.Add('"' + CN_EMAIL_SENDER_ADDRESS + '" NVARCHAR(255),');
            ADOQuery.SQL.Add('"' + CN_EMAIL_SUPPORT_ADDRESS + '" NVARCHAR(255)');

            ADOQuery.ExecSql;

            //* Set default registration e-mail templates
            //SQLSetDefaultEMailTemplates(DataBaseName, True, MemoDefaultEMailTemplateRegistration.Text, MemoDefaultEMailTemplateVersionCode.Text, MemoDefaultEMailTemplateVersionCodeError.Text);

        end;

        ADOQuery.SQL.Clear;

    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;

end;

procedure TFormTool.CheckToUpgradeDataBaseToVersion7(DataBaseName: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;

    try
        //* Check that there's an existing database
        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        //* Check if TEMPLATE_REGISTRATION column exists in TN_SETTINGS
        ADOQuery.SQL.Add('SELECT COLUMN_NAME');
        ADOQuery.SQL.Add('FROM information_schema.COLUMNS');
        ADOQuery.SQL.Add('WHERE TABLE_NAME = ''' + TN_SETTINGS + '''');
        ADOQuery.SQL.Add('AND COLUMN_NAME = ''' + 'AllBundleProductName' + '''');

        ADOQuery.Open;

        //* No "AllBundleProductName" column found, create all new v7 columns
        if DataSource.DataSet.IsEmpty then begin
            //* Set to use our new database (specified by name)
            ADOQuery.SQL.Add('USE ' + DataBaseName + ';');
            ADOQuery.SQL.Add('ALTER TABLE "' + TN_SETTINGS + '" ADD');
            //* "AllBundleProductName"
            ADOQuery.SQL.Add('"' + 'AllBundleProductName' + '" NVARCHAR(255)');

            ADOQuery.ExecSql;

        end;

        ADOQuery.SQL.Clear;

    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;

end;

procedure TFormTool.ReloadProjects;
var
    Icon: TIcon;
    IconBytes: TBytes;
    IconStream: TMemoryStream;
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS);
    ADOQuery.Open;

    LabelRegistrations.Caption := '0';

    ListViewProjects.Clear;
    ImageListProjectIconsSmall.Clear;
    ImageListProjectIconsBig.Clear;
    ImageListProjectIconsSmall.BkColor := ListViewProjects.Color;
    ImageListProjectIconsBig.BkColor := ListViewProjects.Color;

    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin
        with ListViewProjects.Items.Add do begin
            Caption := DataSource.DataSet.FieldByName(CN_PROJECTNAME).AsWideString;
            SubItems.Add(DataSource.DataSet.FieldByName(CN_PROJECT_ID).AsWideString);
            SubItems.Add(DataSource.DataSet.FieldByName(CN_PROJECT_TABLENAME).AsString);
            SubItems.Add(DataSource.DataSet.FieldByName(CN_PROJECT_REG_SEED).AsString);
            IconBytes := DataSource.DataSet.FieldByName(CN_PROJECT_ICON).AsBytes;
            if Length(IconBytes) > 0 then begin
                Icon := TIcon.Create;
                IconStream := TMemoryStream.Create;
                IconStream.Write(Pointer(IconBytes)^, Length(IconBytes));
                IconStream.Seek(0, soBeginning);
                Icon.LoadFromStream(IconStream);
                ImageIndex := ImageListProjectIconsSmall.AddIcon(Icon);
                ImageIndex := ImageListProjectIconsBig.AddIcon(Icon);
                FreeAndNil(IconStream);
                FreeAndNil(Icon);
            end else begin
                ImageIndex := -1;
            end;
            SubItems.Add(DataSource.DataSet.FieldByName(CN_PROJECT_DOWNLOAD_URL).AsWideString);
        end;
        DataSource.DataSet.Next;
    end;

    ADOQuery.Close;

    ADOConnection.Close;

    FillProjectsList;

end;

function TFormTool.SQLAddNewProjectRegistration(ProjectTableName: String; UserName: String; UserEmail: String; RegistrationTime: TDateTime; ShareItEMail: String): Integer;
begin

    Result := 0;

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

    //* Insert a new record
    ADOQuery.SQL.Add('INSERT INTO ' + ProjectTableName);
    ADOQuery.SQL.Add('(' + CN_USER_REGISTRATIONNAME + ', ' + CN_USER_EMAIL + ', ' + CN_USER_REG_TIME + ', ' + CN_USER_SHAREITORDEREMAIL + ') VALUES (:UserName, :Email, :RegistrationTime, :ShareItEMail)');
    //* Specify the values and their data type ftWideString = unicode
    ADOQuery.Parameters.ParamByName('UserName').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('UserName').Value := UserName;
    ADOQuery.Parameters.ParamByName('Email').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('Email').Value := UserEmail;
    ADOQuery.Parameters.ParamByName('RegistrationTime').DataType := ftDateTime;
    ADOQuery.Parameters.ParamByName('RegistrationTime').Value := RegistrationTime;
    ADOQuery.Parameters.ParamByName('ShareItEMail').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('ShareItEMail').Value := ShareItEMail;

    ADOQuery.ExecSql;

    //* Read back new ID
    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT * FROM ' + ProjectTableName + ' WHERE ' + CN_USER_EMAIL + ' = ''' + UserEmail + '''');
    ADOQuery.Open;

    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin
        Result := DataSource.DataSet.FieldByName(CN_USER_ID).AsInteger;
        DataSource.DataSet.Next;
    end;

    ADOConnection.Close;

end;

procedure TFormTool.ReloadSubVersions;
var
    ProjectID: String;
    Seed: String;
    i: Integer;
begin

    ProjectID := ListViewProjects.Selected.SubItems[0];

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME);
    ADOQuery.Open;

    ComboBoxSubVersion.Items.Clear;
    SetLength(ProjectVerCodeSeeds, 0);

    i := 0;
    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin
        SetLength(ProjectVerCodeSeeds, Length(ProjectVerCodeSeeds) + 1);
        //ComboBoxSubVersion.Items.Add(DataSource.DataSet.FieldByName(RN_SUBVERSION_NAME).AsWideString);

        ComboBoxSubVersion.Items.AddObject(DataSource.DataSet.FieldByName(CN_SUBVERSION_NAME).AsWideString, TObject(i));

        Seed := DataSource.DataSet.FieldByName(CN_SUBVERSION_VERCODE_SEED).AsWideString;
        ProjectVerCodeSeeds[i] := StrToFloat(Seed);
        DataSource.DataSet.Next;
        Inc(i);
    end;

    ADOQuery.Close;

    ADOConnection.Close;

    if ComboBoxSubVersion.Items.Count > 0 then begin
        ComboBoxSubVersion.ItemIndex := ComboBoxSubVersion.Items.Count - 1;
    end;

    SortSubVersions;

end;

procedure TFormTool.GetLastSubVersion(ProjectID: String; var SubVersionSeed: Double; var SubVersionName: String);
//var
    //Seed: String;
    //i: Integer;
begin

    SubVersionSeed := 0;
    SubVersionName := '';

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    //ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME);
    ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID);
    //* select top 1 column_name from table_name order by column_name desc;
    //ADOQuery.SQL.Add('SELECT TOP 1 ' + CN_SUBVERSION_VERCODE_SEED + ' FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME + ' DESC');
    //ADOQuery.SQL.Add('SELECT TOP 1 * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME + ' DESC');

    ADOQuery.Open;

    //i := 0;
    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin

        SubVersionSeed := StrToFloat(DataSource.DataSet.FieldByName(CN_SUBVERSION_VERCODE_SEED).AsWideString);
        SubVersionName := DataSource.DataSet.FieldByName(CN_SUBVERSION_NAME).AsWideString;

        DataSource.DataSet.Next;
    end;

    ADOQuery.Close;

    ADOConnection.Close;

end;

function TFormTool.GetSubVersionSeed(ProjectID: String; SubVersionName: String; var SubVersionSeed: Double): Boolean;
//var
    //Seed: String;
    //i: Integer;
begin

    SubVersionSeed := 0;

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    //ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME);
    ADOQuery.SQL.Add('SELECT * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' AND ' + CN_SUBVERSION_NAME + ' = ''' + SubVersionName + '''');
    //* select top 1 column_name from table_name order by column_name desc;
    //ADOQuery.SQL.Add('SELECT TOP 1 ' + CN_SUBVERSION_VERCODE_SEED + ' FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME + ' DESC');
    //ADOQuery.SQL.Add('SELECT TOP 1 * FROM ' + TN_PROJECTS_SUBVERSION + ' WHERE ' + CN_PROJECT_ID + ' = ' + ProjectID + ' ORDER BY ' + CN_SUBVERSION_NAME + ' DESC');

    ADOQuery.Open;

    //i := 0;
    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin

        //if SubVersionName = DataSource.DataSet.FieldByName(CN_SUBVERSION_NAME).AsWideString then begin
            SubVersionSeed := StrToFloatDef(DataSource.DataSet.FieldByName(CN_SUBVERSION_VERCODE_SEED).AsWideString, 0);
            //SubVersionName := DataSource.DataSet.FieldByName(CN_SUBVERSION_NAME).AsWideString;
        //    Break;
        //end;

        DataSource.DataSet.Next;
    end;

    ADOQuery.Close;

    ADOConnection.Close;

    Result := SubVersionSeed <> 0;

end;

procedure TFormTool.ReloadRegistrations;
var
    ProjectTableName: String;
begin

    if NOT Assigned(ListViewProjects.Selected) then begin
        Exit;
    end;

    ProjectTableName := ListViewProjects.Selected.SubItems[1];

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT ' + CN_USER_ID + ', '+ CN_USER_REGISTRATIONNAME + ', ' + CN_USER_EMAIL + ', ' + CN_USER_REG_TIME + ', ' + CN_USER_COMMENTS + ' FROM ' + ProjectTableName);
    ADOQuery.Open;
    try
        ListViewRegs.Clear;
        ListViewRegs.Items.BeginUpdate;
        try
            DataSource.DataSet.First;
            while NOT DataSource.DataSet.Eof do begin
                with ListViewRegs.Items.Add do begin
                    Caption := DataSource.DataSet.FieldByName(CN_USER_ID).AsWideString;
                    SubItems.Add(DataSource.DataSet.FieldByName(CN_USER_REGISTRATIONNAME).AsWideString);
                    SubItems.Add(DataSource.DataSet.FieldByName(CN_USER_EMAIL).AsString);
                    SubItems.Add(DataSource.DataSet.FieldByName(CN_USER_REG_TIME).AsString);
                    SubItems.Add(DataSource.DataSet.FieldByName(CN_USER_COMMENTS).AsString);
                end;
                DataSource.DataSet.Next;
            end;
        finally
            ListViewRegs.Items.EndUpdate;
        end;
    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;
end;

procedure TFormTool.SQLDeleteProjectRegistration(ProjectTableName: String; UserID: Integer);
begin
    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

    //* Insert a new record
    ADOQuery.SQL.Add('DELETE FROM ' + ProjectTableName + ' WHERE ' + CN_USER_ID + ' = ' + IntToStr(UserID));

    ADOQuery.ExecSql;

    ADOConnection.Close;
end;

function SubVersionsCompare(Item1, Item2: Pointer): Integer;
var
    Item1Text: String;
    Item2Text: String;
    Item1MajorVersion: Integer;
    Item1MinorVersion: Integer;
    Item1Release: Integer;
    Item1Build: Integer;
    Item2MajorVersion: Integer;
    Item2MinorVersion: Integer;
    Item2Release: Integer;
    Item2Build: Integer;
begin
    Item1Text := PChar(TSubVersionItem(Item1).Text);
    Item2Text := PChar(TSubVersionItem(Item2).Text);

    try
        Item1MajorVersion := StrToIntDef(Copy(Item1Text, 0, Pos('.', Item1Text) - 1), 0);
        Item1Text := Copy(Item1Text, Pos('.', Item1Text) + 1, Length(Item1Text));
        try
            Item1MinorVersion := StrToIntDef(Copy(Item1Text, 0, Pos('.', Item1Text) - 1), 0);
            Item1Text := Copy(Item1Text, Pos('.', Item1Text) + 1, Length(Item1Text));
        except
            Item1MinorVersion := 0;
        end;
        try
            Item1Release := StrToIntDef(Copy(Item1Text, 0, Pos('.', Item1Text) - 1), 0);
            Item1Text := Copy(Item1Text, Pos('.', Item1Text) + 1, Length(Item1Text));
        except
            Item1Release := 0;
        end;
        try
            Item1Build := StrToIntDef(Copy(Item1Text, 0, Length(Item1Text)), 0);
        except
            Item1Build := 0;
        end;

        Item2MajorVersion := StrToIntDef(Copy(Item2Text, 0, Pos('.', Item2Text) - 1), 0);
        Item2Text := Copy(Item2Text, Pos('.', Item2Text) + 1, Length(Item2Text));
        try
            Item2MinorVersion := StrToIntDef(Copy(Item2Text, 0, Pos('.', Item2Text) - 1), 0);
            Item2Text := Copy(Item2Text, Pos('.', Item2Text) + 1, Length(Item2Text));
        except
            Item2MinorVersion := 0;
        end;
        try
            Item2Release := StrToIntDef(Copy(Item2Text, 0, Pos('.', Item2Text) - 1), 0);
            Item2Text := Copy(Item2Text, Pos('.', Item2Text) + 1, Length(Item2Text));
        except
            Item2Release := 0;
        end;
        try
            Item2Build := StrToIntDef(Copy(Item2Text, 0, Length(Item2Text)), 0);
        except
            Item2Build := 0;
        end;

        if Item1MajorVersion = Item2MajorVersion then begin
            if Item1MinorVersion = Item2MinorVersion then begin
                if Item1Release = Item2Release then begin
                    if Item1Build = Item2Build then begin
                        Result := 0;
                        Exit;
                    end else begin
                        if Item1Build > Item2Build then begin
                            Result := 1;
                            Exit;
                        end else begin
                            Result := -1;
                            Exit;
                        end;
                    end;
                end else begin
                    if Item1Release > Item2Release then begin
                        Result := 1;
                        Exit;
                    end else begin
                        Result := -1;
                        Exit;
                    end;
                end;
            end else begin
                if Item1MinorVersion > Item2MinorVersion then begin
                    Result := 1;
                    Exit;
                end else begin
                    Result := -1;
                    Exit;
                end;
            end;
        end else begin
            if Item1MajorVersion > Item2MajorVersion then begin
                Result := 1;
                Exit;
            end else begin
                Result := -1;
                Exit;
            end;
        end;
    except
        Result := 0;
    end;
end;

procedure TFormTool.SortSubVersions;
var
    SubVersions: TList;
    i: Integer;
    Text: String;
    Item: TSubVersionItem;
    Index: Integer;
begin
    SubVersions := TList.Create;
    try
        for i := 0 to ComboBoxSubVersion.Items.Count - 1 do begin
            Text := ComboBoxSubVersion.Items[i];
            Item := TSubVersionItem.Create;
            GetMem(Item.Text, Length(Text) * 2 + 2);
            StrLCopy(Item.Text, PChar(Text), Length(Text));
            Item.Index := i;
            SubVersions.Add(Pointer(Item));
        end;
        SubVersions.Sort(SubVersionsCompare);
        ComboBoxSubVersion.Clear;
        for i := 0 to SubVersions.Count - 1 do begin

            Text := PChar(TSubVersionItem(Pointer(SubVersions.Items[i])).Text);
            Index := TSubVersionItem(Pointer(SubVersions.Items[i])).Index;

            ComboBoxSubVersion.Items.AddObject(Text, TObject(Index));

            TSubVersionItem(Pointer(SubVersions.Items[i])).Free;
        end;
    finally
        FreeAndNil(SubVersions);
    end;
end;

procedure TFormTool.SQLLoadDefaultEMailTemplates(var EMailTemplateRegistration, EMailTemplateVersionCode, EMailTemplateVersionCodeError: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT * FROM ' + TN_SETTINGS + ' WHERE ' + CN_SETTINGS_VERSION + ' = ' + IntToStr(CURRENT_SETTINGS_VERSION));
    ADOQuery.Open;

    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin
        EMailTemplateRegistration := DataSource.DataSet.FieldByName(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_REGISTRATION).AsWideString;
        EMailTemplateVersionCode := DataSource.DataSet.FieldByName(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE).AsWideString;
        EMailTemplateVersionCodeError := DataSource.DataSet.FieldByName(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE_ERROR).AsWideString;
        DataSource.DataSet.Next;
    end;

    ADOQuery.Close;

    ADOConnection.Close;
end;

function TFormTool.SQLSetDefaultEMailTemplates(DataBaseName: String; Create: Boolean; EMailTemplateRegistrationText, EMailTemplateVersionCodeText, EMailTemplateVersionCodeErrorText: String): Boolean;
begin

    //Result := False;

    Screen.Cursor := crAppStart;
    try
        ADOConnection.Close;

        ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + DataBaseName + ';');

        if Create then begin
            //* Insert a new record
            ADOQuery.SQL.Add('INSERT INTO ' + TN_SETTINGS);
            ADOQuery.SQL.Add('(' + CN_SETTINGS_VERSION + ', ' + CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_REGISTRATION + ', ' + CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE + ', ' + CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE_ERROR + ') VALUES (:a, :b, :c, :d)');
            //* Specify the values and their data type ftWideString = unicode
            ADOQuery.Parameters.ParamByName('a').DataType := ftInteger;
            ADOQuery.Parameters.ParamByName('a').Value := CURRENT_SETTINGS_VERSION;
            ADOQuery.Parameters.ParamByName('b').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('b').Value := EMailTemplateRegistrationText;
            ADOQuery.Parameters.ParamByName('c').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('c').Value := EMailTemplateVersionCodeText;
            ADOQuery.Parameters.ParamByName('d').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('d').Value := EMailTemplateVersionCodeErrorText;
        end else begin
            //* Update the (hard-coded) current (CURRENT_SETTINGS_VERSION) record
            ADOQuery.SQL.Add('UPDATE ' + TN_SETTINGS);
            ADOQuery.SQL.Add('SET ' + CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_REGISTRATION + ' = :a,');
            ADOQuery.SQL.Add(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE + ' = :b,');
            ADOQuery.SQL.Add(CN_SETTINGS_DEFAULT_EMAIL_TEMPLATE_VERSIONCODE_ERROR + ' = :c');
            ADOQuery.SQL.Add('WHERE ' + CN_SETTINGS_VERSION + ' = ' + IntToStr(CURRENT_SETTINGS_VERSION));
            ADOQuery.Parameters.ParamByName('a').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('a').Value := EMailTemplateRegistrationText;
            ADOQuery.Parameters.ParamByName('b').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('b').Value := EMailTemplateVersionCodeText;
            ADOQuery.Parameters.ParamByName('c').DataType := ftWideString;
            ADOQuery.Parameters.ParamByName('c').Value := EMailTemplateVersionCodeErrorText;
        end;

        ADOQuery.ExecSql;

        ADOQuery.SQL.Clear;

        ADOQuery.Close;

        ADOConnection.Close;

        Result := True;
    finally
        Screen.Cursor := crDefault;
    end;
end;

procedure TFormTool.ReloadProjectsWithExceptionHandling;
begin
    Screen.Cursor := crAppStart;
    try
        try
            ReloadProjects;
            ListViewProjectsSelectItem(Self, nil, False);
        except
            on E: Exception do begin
                MessageDlg('Error: ' + E.Message, mtError, [mbOk], 0);
            end;
        end;
    finally
        Screen.Cursor := crDefault;
    end;
end;

procedure TFormTool.ReloadRegistration(Item: TListItem);
var
    ProjectTableName: String;
begin

    ProjectTableName := ListViewProjects.Selected.SubItems[1];

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
    //* Get all data
    ADOQuery.SQL.Add('SELECT ' + CN_USER_REGISTRATIONNAME + ', ' + CN_USER_EMAIL + ', ' + CN_USER_REG_TIME + ', ' + CN_USER_COMMENTS + ' FROM ' + ProjectTableName + ' WHERE ' + CN_USER_ID + ' = ' + Item.Caption);
    ADOQuery.Open;

    //ListViewRegs.Clear;

    ListViewRegs.Items.BeginUpdate;

    DataSource.DataSet.First;
    while NOT DataSource.DataSet.Eof do begin
        with Item do begin
            //Caption := DataSource.DataSet.FieldByName(CN_USER_ID).AsWideString;
            SubItems[0] := DataSource.DataSet.FieldByName(CN_USER_REGISTRATIONNAME).AsWideString;
            SubItems[1] := DataSource.DataSet.FieldByName(CN_USER_EMAIL).AsString;
            SubItems[2] := DataSource.DataSet.FieldByName(CN_USER_REG_TIME).AsString;
            SubItems[3] := DataSource.DataSet.FieldByName(CN_USER_COMMENTS).AsString;
        end;
        DataSource.DataSet.Next;
    end;

    ListViewRegs.Items.EndUpdate;

    ADOQuery.Close;

    ADOConnection.Close;

end;

procedure TFormTool.WndProc(var Msg: TMessage);
var
    P: TPoint;
begin
    case Msg.Msg of
        MSG_TRAY_ICON: case Msg.LParam of
            WM_LBUTTONDBLCLK: begin
                TimerCheckIncomingMail.Enabled := False;
                Show;
            end;
            WM_LBUTTONDOWN: begin
                TimerCheckIncomingMail.Enabled := False;
                Show;
            end;
            //WM_MBUTTONDOWN: SwitchPPO; // SwitchALU;
            WM_RBUTTONDOWN: begin
                GetCursorPos(P);
                PopupMenuTrayIcon.Popup(P.x,P.y);
                //Show;
            end;
            NIN_BALLOONUSERCLICK: begin
                TimerCheckIncomingMail.Enabled := False;
                Show;
            end;
        end;
    end;
    inherited;
end;

end.
